package be.iminds.ilabt.jfed.rspec.model.imutable_impl;

import be.iminds.ilabt.jfed.rspec.model.Channel;
import be.iminds.ilabt.jfed.rspec.parser.ExtraXml;
import be.iminds.ilabt.jfed.util.common.GeniUrn;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.function.Function;
import java.util.stream.Collectors;

public class ImmutableChannel implements Channel {
    private static final Logger LOG = LoggerFactory.getLogger(ImmutableChannel.class);

    private final GeniUrn componentManagerId;
    private final GeniUrn componentId;
    private final String componentName;
    private final String frequency;

    private final double editorX;
    private final double editorY;

    private final List<String> leaseIdRefs;
    private final List<ExtraXml> extraXml;

    private static <T> List<T> listInit(List<T> orig) {
        if (orig == null) return null;
        return Collections.unmodifiableList(new ArrayList<>(orig));
    }

    public ImmutableChannel(Channel orig) {
        this.componentId = orig.getComponentId();
        this.componentManagerId = orig.getComponentManagerId();
        this.componentName = orig.getComponentName();
        this.frequency = orig.getFrequency();
        this.editorX = orig.getEditorX();
        this.editorY = orig.getEditorY();
        this.leaseIdRefs = listInit(orig.getLeaseIdRefs());
        this.extraXml = listInit(orig.getExtraXml());
    }

    public GeniUrn getComponentId() {
        return componentId;
    }

    public void setComponentId(GeniUrn componentId) {
        throw new UnsupportedOperationException();
    }

    @Override
    public void setComponentId(String value) {
        throw new UnsupportedOperationException();
    }

    public GeniUrn getComponentManagerId() {
        return componentManagerId;
    }

    public void setComponentManagerId(GeniUrn componentManagerId) {
        throw new UnsupportedOperationException();
    }

    @Override
    public void setComponentManagerId(String value) {
        throw new UnsupportedOperationException();
    }

    public String getComponentName() {
        return componentName;
    }

    public void setComponentName(String componentName) {
        throw new UnsupportedOperationException();
    }

    public String getFrequency() {
        return frequency;
    }

    public void setFrequency(String frequency) {
        throw new UnsupportedOperationException();
    }

    @Override
    public double getEditorX() {
        return editorX;
    }

    @Override
    public void setEditorX(double value) {
        throw new UnsupportedOperationException();
    }

    @Override
    public double getEditorY() {
        return editorY;
    }

    @Override
    public void setEditorY(double value) {
        throw new UnsupportedOperationException();
    }

    @Override
    public void addLeaseIdRef(String leaseIdRef) {
        leaseIdRefs.add(leaseIdRef);
    }

    @Override
    public List<String> getLeaseIdRefs() {
        return leaseIdRefs;
    }

    @Override
    public List<ExtraXml> getExtraXml() {
        return extraXml;
    }
}
